﻿using System;

namespace Persistence {
  /// <summary>
  /// combines multiple used static methods into one class
  /// </summary>
  public class DatabaseUtil {
    /// <summary>
    /// creates and returns a database connection, if possible
    /// </summary>
    /// <returns>database connection (could be null)</returns>
    public static DataClassesDataContext createDataClassesDataContext() {
      DataClassesDataContext db;
      try {
        db = new Persistence.DataClassesDataContext(@"C:\TEMP\HeuristicLabTemp.mdf");
      }
      catch (Exception) {
        return null;
      }
      return db;
    }

    /// <summary>
    /// creates a new database out of the LINQ to SQL classes
    /// </summary>
    /// <param name="db">DataClassesDataContext</param>
    public static void createDatabase(DataClassesDataContext db) {
      if (db == null) {
        throw new ArgumentNullException("db");
      }
      
      if (db.DatabaseExists()) {
        Console.WriteLine("Deleting old database...");
        db.DeleteDatabase();
        Console.WriteLine("Deleted old database!");
      }

      Console.WriteLine("Creating new database...");
      db.CreateDatabase();
      Console.WriteLine("Created new database!");
    }
  }
}
